/* src/web2cs-engine.c - Moteur du Web2CS
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: web2cs-engine.c,v 1.21 2003/12/13 23:36:51 romexzf Exp $
 */

#if 0
#include "main.h"
#ifdef TESTBOT
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <fcntl.h>
#include <sys/time.h>
#include <errno.h>
#include "web2cs.h"

extern struct w2c_commands w2c_cmds[];
extern const int w2c_port;
int bind_sock;
int CONtotal = 0;
int WEBtrafficUP = 0;
int WEBtrafficDL = 0;
fd_set socks;        /* Socket file descriptors we want to wake up for, using select() */
fd_set master;
int highsock;        /* Highest #'d file descriptor, needed for select() */
struct w2c_clientinfo *w2c_clihead = NULL;
struct w2c_host_allow *w2c_hallowhead = NULL;
typedef struct w2c_clieninfo w2c_cli;

void w2c_setnonblocking(int sock)
{
	int opts = fcntl(sock, F_GETFL);

	if (opts < 0)
	{
		putlog(LOG_ERREURS, "Erreur lors de fcntl(F_GETFL)");
		exit(EXIT_FAILURE);
	}
	opts |= O_NONBLOCK;
	if (fcntl(sock, F_SETFL, opts) < 0)
	{
		putlog(LOG_ERREURS, "Erreur lors de fcntl(F_SETFL)");
		exit(EXIT_FAILURE);
	}
	return;
}

void w2c_closesocks(void)
{
	int i = 0;

	socks = master;

	for(;i <= highsock;i++)
		if (FD_ISSET(i, &socks)) close(i);

	FD_ZERO(&socks);
	FD_ZERO(&master);
	return;
}

void w2c_initsocket(void)
{
	int reuse_addr = 1;
	struct sockaddr_in server_address; /* bind info structure */

	bind_sock = socket(AF_INET, SOCK_STREAM, 0); /* on demande un socket */
	if (bind_sock < 0)
	{
		putlog(LOG_ERREURS, "Impossible de crer le serveur de DB.");
		puts("Impossible de crer le serveur de DB, exiting");
		exit(EXIT_FAILURE);
	}
	fcntl(bind_sock, F_SETFL, O_NONBLOCK);

	setsockopt(bind_sock, SOL_SOCKET, SO_REUSEADDR, &reuse_addr, sizeof(reuse_addr));

	memset((char *) &server_address, 0, sizeof(server_address));
	server_address.sin_family = AF_INET;
	server_address.sin_addr.s_addr = INADDR_ANY;
	server_address.sin_port = htons(w2c_port);

	if (bind(bind_sock, (struct sockaddr *) &server_address, sizeof(server_address)) < 0 )
	{
		printf("Impossible d'couter au port %d (Dj pris?)\n", w2c_port);
		puts("Impossible de crer le serveur de DB, exiting");
		putlog(LOG_ERREURS, "Impossible d'couter au port de DB.");
		close(bind_sock);
		exit(EXIT_FAILURE);
	}

	listen(bind_sock,5);

	highsock = bind_sock;
	FD_ZERO(&master);
	FD_ZERO(&socks);

	FD_SET(bind_sock, &master);
	socks = master;
	printf("Serveur de base de donnes du Channel Service OK (Port %d)\n", w2c_port);
	return;
}

int w2c_checksocks(void)
{
	int readsocks;
	struct timeval timeout;

	timeout.tv_sec = 0;
	timeout.tv_usec = 100;

	socks = master;
	readsocks = select(highsock+1, &socks, NULL, NULL, &timeout);

	if (readsocks == -1 && errno != EINTR)
	{
		putlog(LOG_ERREURS, "Erreur lors de select() (%d: %s)", errno, strerror(errno));
		exit(EXIT_FAILURE);
	}
	else if (readsocks <= 0) return 0;
	return 1;
}

struct w2c_clientinfo *w2c_addclient(int i, char *a1)
{
	struct w2c_clientinfo *new, *tmp;

	if(!(new = calloc(1, sizeof(struct w2c_clientinfo)))) return NULL;

	new->next = NULL;
	new->socket = i;
	new->user = NULL;

	strcpy(new->ip, a1);
	new->flag = 0;
	if(!w2c_clihead) w2c_clihead = new;
	else
	{
		for(tmp = w2c_clihead; tmp->next; tmp = tmp->next);
		if(!tmp->next) tmp->next = new;
	}

	return new;
}

void w2c_delclient(struct w2c_clientinfo *del)
{
	struct w2c_clientinfo *last = NULL, *next = w2c_clihead;

	while(next)
	{
		if(next == del) break;
		last = next;
		next = next->next;
	}
	if(next)
	{
		if(next == w2c_clihead) w2c_clihead = w2c_clihead->next;
		else last->next = next->next;

		close(next->socket);
		FD_CLR(next->socket, &master);
		free(del);
		del = NULL;
	}
	return;
}

struct w2c_clientinfo *w2c_findclient(int i)
{
	struct w2c_clientinfo *cli = w2c_clihead;
	for(;cli && cli->socket != i;cli=cli->next);
	return cli;
}

void w2c_parsemsg(struct w2c_clientinfo *source, char *msg)
{
	char *parv[256], buf[512] = {0}, *ptr, *cmd;
	int parc = 1, i = 0;
	aChan *chaninfo = NULL;

	strip_newline(msg);
	strncpy(buf, msg, 512);

	cmd = strtok(buf, " ");
	if(!cmd) cmd = msg;
	else
		for(; (ptr=strtok(NULL, " ")) && parc < 256 ; parc++)
		{
			if(strlen(ptr) < 256) parv[parc] = ptr;
			else
			{
				w2c_sendrpl(source, RPL_101);
				return;
			}
		}

	parc--;

	for (; w2c_cmds[i].func != NULL; i++)
		if (!strcasecmp(w2c_cmds[i].cmd,cmd))
		{
			if(!(source->flag & W2C_ALLOWED) && strcasecmp(cmd, "PASS"))
			{
				w2c_exit_client(source, "Non autoris");
				return;
			}
			if(parc < w2c_cmds[i].args)
			{
				w2c_sendrpl(source, RPL_102);
				return;
			}
			if((!source->user && w2c_cmds[i].level) || (source->user && w2c_cmds[i].level > source->user->level))
			{
				w2c_sendrpl(source, RPL_107);
				return;
			}
			if(w2c_cmds[i].chan && parc && !(chaninfo=getchaninfo(parv[1])))
			{
				w2c_sendrpl(source, RPL_106, parv[1]);
				return;
			}
			w2c_cmds[i].func(source, chaninfo, parc, parv);
			return;
		}

	w2c_sendrpl(source, RPL_103);
	return;
}


/*
 * Dbut : parv[1]
 * Fin : parv[parc]
 */

int w2c_sendrpl(struct w2c_clientinfo *dest, const char *pattern, ...)
{
	char buf[1024] = {0};
	va_list vl;
	int len;

	va_start(vl, pattern);
	vsnprintf(buf, 1024, pattern, vl);
	va_end(vl);

	len = strlen(buf);
	WEBtrafficUP += len;

	return send(dest->socket, buf, len, 0);
}

int w2c_exit_client(struct w2c_clientinfo *client, const char *msg)
{
	w2c_sendrpl(client, RPL_001, msg ? msg : "bye");
	w2c_delclient(client);
	for(client=w2c_clihead;client;client=client->next)
		if(client->socket > highsock) { highsock = client->socket; break; }
	return 0;
}

#endif
#endif

/* NEW CS LIVE*/

#include "main.h"
#ifdef TESTBOT
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <fcntl.h>
#include <sys/time.h>
#include <errno.h>
#include "web2cs.h"
#include "hash.h"
#include "outils.h"
#include "debug.h"
#include "ban.h"

#define MAXPARAM 10
int w2c_port;
char w2c_pass[50];

int bind_sock;
int CONtotal = 0;
int WEBtrafficUP = 0;
int WEBtrafficDL = 0;
fd_set socks;        /* Socket file descriptors we want to wake up for, using select() */
fd_set master;
int highsock;        /* Highest #'d file descriptor, needed for select() */


/* dear global vars */
WClient myWClient[MAXWEBCON+1];

w2c_hallow *w2c_hallowhead = NULL;

static int w2c_passwd(WClient *cl, int parc, char **parv)
{
	if(IsAuth(cl)) return 0; /* On devrait pas kill le sock?*/
	if(strcmp(parv[1], w2c_pass))
		return w2c_exit_client(cl, "erreur Mauvais pass");
	cl->flag |= W2C_AUTH;
	return w2c_sendrpl(cl, "OK");
}

static int w2c_login(WClient *cl, int parc, char **parv)
{
	anUser *user;
	char host[20] = "web@";

	if(cl->user)
	{
		aMemo *memo = cl->user->memohead;
		int r = 0;
		for(;memo;memo = memo->next) if(!memo->read) r++;
		w2c_sendrpl(cl, "login %d %d", cl->user->level, r);
		return w2c_exit_client(cl, "OK login details.");
	}
	if(!(user = getuserinfo(parv[1])) || !checkpass(parv[2], user))
		return w2c_exit_client(cl, "erreur Mauvais Username/Pass");

	user->lastseend = time(NULL); /* login stuff : lastseen, lastlogin*/
	strcat(host, parv[3]);
	str_dup(&user->lastlogin, host);
	cl->user = user;

	return w2c_sendrpl(cl, "OK user logued");
}

#define SHOW_TOPIC 		0x01
#define SHOW_RIGHT 		0x02
#define SHOW_USERS 		0x04
#define SHOW_DEFMODES 	0x08
#define SHOW_OWNER 		0x10
#define SHOW_BANS 		0x20
#define SHOW_ACCESS 	0x40
#define SHOW_ALL 		0x80

static int w2c_channel(WClient *cl, int parc, char **parv)
{
	aChan *chan = getchaninfo(parv[1]);

	if(!strcasecmp(parv[2], "info"))
	{
		unsigned int infos = 0, i;
		aLink *lp;

		if(!chan) return w2c_exit_client(cl, "erreur Salon non reg");
		else if(parc < 4) return w2c_exit_client(cl, "OK Salon reg");

		if(IsAnAdmin(cl->user) || GetAccessIbyUserI(cl->user, chan)) infos |= SHOW_RIGHT;
		if(chan->mode.modes & (C_MSECRET|C_MPRIVATE) && !(infos & SHOW_RIGHT))
			return w2c_exit_client(cl, "erreur Ces infos ne vous sont disponibles.");

		for(lp = chan->access;lp && lp->value.a->level != OWNERLEVEL;lp = lp->next);/* recherche de l'owner*/

		for(i = 3;i < parc;++i)
		{
			if(!strcasecmp(parv[i], "all"))
			{
				infos |= SHOW_ALL;
				break;
			}
			else if(!strcasecmp(parv[i], "topic")) infos |= SHOW_TOPIC;
			else if(!strcasecmp(parv[i], "owner")) infos |= SHOW_OWNER;
			else if(!strcasecmp(parv[i], "users") && infos&SHOW_RIGHT) infos |= SHOW_USERS;
			else if(!strcasecmp(parv[i], "bans")) infos |= SHOW_BANS;
			else if(!strcasecmp(parv[i], "access")) infos |= SHOW_ACCESS;
		}

		if(!infos) return w2c_exit_client(cl, "OK Salon reg");/* aucune infos demandes*/

		if(infos & SHOW_OWNER)/* OK, construisons/envoyons les infos*/
			w2c_sendrpl(cl, "owner %s", lp ? lp->value.a->user->nick : "<Aucun>");
		if(infos & SHOW_ALL)
		{
			w2c_sendrpl(cl, "=owner=%s ct=%ld banlevel=%d cml=%d bantype=%s bantime=%ld",
				lp ? lp->value.a->user->nick : "<Aucun>", chan->creation_time, chan->banlevel,
					chan->cml, GetBanType(chan), chan->bantime);
			w2c_sendrpl(cl, "options %s", GetChanOptions(chan));
			if(*chan->deftopic) w2c_sendrpl(cl, "deftopic %s", chan->deftopic);
			if(chan->defmodes.modes) w2c_sendrpl(cl, "defmodes %s",
				chan->defmodes.modes & C_MKEY && infos & SHOW_RIGHT ? GetCModes(chan->defmodes) : "-masqu-");
			if(chan->mode.modes) w2c_sendrpl(cl, "modes %s",
				chan->mode.modes & C_MKEY && infos & SHOW_RIGHT ? GetCModes(chan->mode) : "-masqu-");
			if(*chan->welcome && CSetWelcome(chan)) w2c_sendrpl(cl, "welcome %s", chan->welcome);
			if(infos & SHOW_RIGHT && chan->motd) w2c_sendrpl(cl, "motd %s", chan->motd);
		}
		if(infos & (SHOW_ALL|SHOW_TOPIC) && *chan->topic)
			w2c_sendrpl(cl, "topic %s", chan->topic);
	}
	return 0;
}

static struct w2c_commands {
   char cmd[15];
   int (*func) (WClient *, int, char **);
   int args;
} w2c_cmds[] = {
 {  "login",		w2c_login, 		3		},
 {  "channel",		w2c_channel, 	2		},
 {  "pass",			w2c_passwd,		1		},
/*
 {  "ACCESS",		w2c_access,		1,		1, 1 },
 {  "SET",		w2c_set,		1,		1, 0 },
 {  "USER",		w2c_user,		1,		2, 0 },
 {  "CHAN",		w2c_chan,		1,		2, 0 },
 {  "MYACCESS",		w2c_myaccess,		1,		0, 0 },
 {  "WHOISON",		w2c_whoison,		2,		1, 1 },
 {  "REGISTER",		w2c_reg_user,		0,		3, 0 },
 {  "MEMOS",		w2c_memos,		1,		2, 0 },
 {  "MODUSER",		w2c_moduser,		1,		3, 1 },
 {  "CHANOPT",		w2c_chanopt,		400,		2, 1 },*/

};

void w2c_setnonblocking(int sock)
{
	int opts = fcntl(sock, F_GETFL);

	if(opts < 0) Debug(W_MAX, "Erreur lors de fcntl(F_GETFL)");
	else if(fcntl(sock, F_SETFL, opts | O_NONBLOCK) < 0)
		Debug(W_MAX, "Erreur lors de fcntl(F_SETFL)");
	else return;
	exit(EXIT_FAILURE);
}

void w2c_closesocks(void)
{
	int i = 0;

	socks = master;

	for(;i <= highsock;i++)
		if (FD_ISSET(i, &socks)) close(i);

	FD_ZERO(&socks);
	FD_ZERO(&master);
	return;
}

void w2c_initsocket(void)
{
	int reuse_addr = 1;
	struct sockaddr_in server_address = {0}; /* bind info structure */

	bind_sock = socket(AF_INET, SOCK_STREAM, 0); /* on demande un socket */
	if (bind_sock < 0)
	{
		Debug(W_MAX|W_TTY, "Impossible de crer le serveur de DB. (socket non cr)");
		exit(EXIT_FAILURE);
	}
	fcntl(bind_sock, F_SETFL, O_NONBLOCK);

	setsockopt(bind_sock, SOL_SOCKET, SO_REUSEADDR, &reuse_addr, sizeof reuse_addr);

	server_address.sin_family = AF_INET;
	server_address.sin_addr.s_addr = INADDR_ANY;
	server_address.sin_port = htons(w2c_port);

	if (bind(bind_sock, (struct sockaddr *) &server_address, sizeof server_address) < 0 )
	{
		Debug(W_MAX|W_TTY, "Impossible d'couter au port %d pour le serveur de DB. (Dj utilis?)", w2c_port);
		close(bind_sock);
		exit(EXIT_FAILURE);
	}

	listen(bind_sock, 5);

	highsock = bind_sock;
	FD_ZERO(&master);
	FD_ZERO(&socks);

	FD_SET(bind_sock, &master);
	socks = master;
	printf("Serveur de base de donnes du Channel Service OK (Port %d)\n", w2c_port);
	return;
}

int w2c_checksocks(void)
{
	int readsocks;
	struct timeval timeout;

	timeout.tv_sec = 0;
	timeout.tv_usec = 100;

	socks = master;
	readsocks = select(highsock+1, &socks, NULL, NULL, &timeout);

	if (readsocks == -1 && errno != EINTR)
	{
		putlog(LOG_ERREURS, "Erreur lors de select() (%d: %s)", errno, strerror(errno));
		exit(EXIT_FAILURE);
	}
	else if (readsocks <= 0) return 0;
	return 1;
}

static int w2c_findcmd(const char *cmd)
{
	int i = 0;
	for(;i < ASIZE(w2c_cmds);i++)
		if(!strcasecmp(w2c_cmds[i].cmd, cmd)) return i;
	return -1;
}

int w2c_parsemsg(int fd, const char *msg)
{
	char buf[512], *parv[MAXPARAM+1];
	register char *ptr;
	int cmd, i = 1;
	WClient *cl = &myWClient[fd];

	if((!IsAuth(cl) && strncasecmp(msg, "pass ", 5))
		|| (!cl->user && strncasecmp(msg, "login ", 6)))
			return w2c_exit_client(fd, "erreur Non autoris");

	Strncpy(buf, msg, sizeof buf -1);
	parv[0] = buf; /* cmd*/
	if(!(ptr = strchr(buf, ' ')))
		return w2c_exit_client(fd, "erreur Syntaxe incorrecte");

	*ptr++ = 0;

	if((cmd = w2c_findcmd(parv[0])) < 0)
		return w2c_exit_client(fd, "erreur Commande inconnue");

	while(*ptr)
	{
		while(*ptr == ' ') *ptr++ = 0; /* suppression des espaces*/
		if(!*ptr || i >= MAXPARAM) break;
		else parv[i++] = ptr;
		while(*ptr && *ptr != ' ') ptr++;
	}
	parv[i] = NULL;

	if(i <= w2c_cmds[cmd].args) return w2c_exit_client(fd, "erreur Syntaxe incorrecte");
	w2c_cmds[cmd].func(cl, i, parv);
	return 0;
}
/******/

/*
 * Dbut : parv[1]
 * Fin : parv[parc]
 */

int w2c_sendrpl(WClient *cl, const char *pattern, ...)
{
	char buf[1024];
	va_list vl;
	int len;

	va_start(vl, pattern);
	len = vsnprintf(buf, sizeof buf, pattern, vl);
	va_end(vl);
	WEBtrafficUP += len;

	return send(cl->fd, buf, len, 0);
}

int w2c_exit_client(WClient *cl, const char *msg)
{
	int i = 0;
	if(msg && *msg) w2c_sendrpl(cl, msg);
	w2c_delclient(cl);

	for(;i < ASIZE(myWClient);i++)
		if(myWClient[i].fd > highsock) { highsock = myWClient[i].fd; break; }
	return 0;
}


WClient *w2c_addclient(int fd, char *ip)
{
	WClient *new = NULL;

	if(fd >= ASIZE(myWClient))
		Debug(W_WARN, "W2C: Trop de clients connects! (Dernier %d sur %s, Max: %d)",
			fd, ip, ASIZE(myWClient));
	else if(!(myWClient[fd].flag & W2C_FREE))
		Debug(W_MAX|W_WARN, "W2C: Connexion sur un slot dj occup!? (%s -> %d[%s])",
			ip, fd, myWClient[fd].ip);
	else
	{
		new = &myWClient[fd];
		new->fd = fd;
		strcpy(new->ip, ip);
		new->user = NULL;
		new->flag = 0;
	}

	return new;
}

void w2c_delclient(WClient *del)
{
	close(del->fd);
	FD_CLR(del->fd, &master);
	memset(del, 0, sizeof(WClient));
	del->flag |= W2C_FREE;
	return;
}

#endif
